const consoleUtils = require('../src/utils/ConsoleUtils');
const requestUtils = require('../src/utils/RequestUtils');

let start = Date.now();
let args = process.argv;
if (args.length < 3) {
    consoleUtils.out({
        "success": false,
        "type": "IllegalArgumentException",
        title: "传入参数不正确",
        content: "传入参数不正确：请传递构件编号！"
    });
}else{
    let componentCode = args[2];
    let data = {
        commander: 'delete',
        componentCode: componentCode
    };
    let promise = requestUtils.request(data);
    promise.then(()=>{
        consoleUtils.out({
            "success": true,
            "type": "ComponentDeleteSuccess",
            title: "构件移除成功",
            content: `构件移除成功,耗时【${Date.now()-start}】毫秒!`
        });
    }).catch(err=>{
        consoleUtils.out({
            success : false,
            type : "RequestException",
            title:"请求服务失败！",
            content:typeof(err)=="string" ? err:(err.stack ? err.stack:err.message)
        });
    });
}