//本命令输出自定义窗体模板信息，目前只包括node_modules,后续窗体源码模板生成需要支持
let args = process.argv;
const fs = require('fs');
const path = require('path');
const ioUtils = require('../src/utils/IOUtils');
const fileUtils = require('../src/utils/FileUtils');
const consoleUtils = require('../src/utils/ConsoleUtils');
const md5File = require('md5-file');
const NodejsPluginUpdater = require('../src/updater/NodejsPluginUpdater');

let start = Date.now();
if (args.length < 4) {
    consoleUtils.out({
        "success": false,
        "type": "IllegalArgumentException",
        title: "传入参数不正确",
        content: "传入参数不正确：请传递构件源码以及目标目录信息！"
    });
} else {
    let promises = [];
    let srcDir = args[2],distDir = args[3];
    let pluginUpdater = new NodejsPluginUpdater(srcDir);
    let promise = pluginUpdater.update();
    promises.push(promise);
    fs.readdir(srcDir,(err,fileNames)=>{
        if(err){
            consoleUtils.out({
                "success": false,
                "type": "ReadDirException",
                title: "读取文件夹失败",
                content: typeof(err)=='string' ? err:(err.stack ? err.stack:err.message)
            });
        }else{
            fileNames.forEach(fileName=>{
                if(fileName!=="node_modules"){
                    let absPath = path.resolve(srcDir,fileName);
                    let aimPath = path.resolve(distDir,fileName);
                    let promise = ioUtils.copyWithFilter(absPath,aimPath,(srcPath,distPath)=>{
                        if(fs.existsSync(distPath)){
                            return md5File.sync(srcPath)!==md5File.sync(distPath);
                        }
                        return true;
                    });
                    promises.push(promise);
                }
            });
        }
    });
    Promise.all(promises).then(()=>{
        consoleUtils.out({
            "success": true,
            "type": "ImportSuccess",
            title: "构件导入成功",
            content: `构件导入成功,耗时【${Date.now()-start}】毫秒！`
        });
    }).catch(err=>{
        consoleUtils.out({
            "success": false,
            "type": "ImportException",
            title: "构件导入失败",
            content: typeof(err)=='string' ? err:(err.stack ? err.stack:err.message)
        });
    });
}