#!/usr/bin/env node

const requestUtils = require('../src/utils/RequestUtils');
const consoleUtils = require('../src/utils/ConsoleUtils');

let args = process.argv;
if (args.length < 3) {
    consoleUtils.out({
        "success":false,
        "type":"IllegalArgumentException",
        title:"传入参数不正确",
        content:"传入参数不正确：请传递构件源码路径信息！"
    });
} else {
    let componentSrcPath = args[2];
    let nopreview = args[3] == 'nopreview';
    let data = {
        commander: 'webpack',
        componentSrc: componentSrcPath,
        nopreview: nopreview
    };
    let promise = requestUtils.request(data);
    promise.then(result=>{
        consoleUtils.out(result);
    }).catch(err=>{
        consoleUtils.out({
            success : false,
            type : "RequestException",
            title:"请求服务失败！",
            content:typeof(err)=="string" ? err:(err.stack ? err.stack:err.message)
        });
    });
}