#!/usr/bin/env node

//本命令输出自定义窗体模板信息，目前只包括node_modules,后续窗体源码模板生成需要支持
let args = process.argv;
const NodePluginExporter = require('../src/utils/NodePluginExporter');
const ComponentTemplateGenerator = require('../src/template/ComponentTemplateGenerator');
const consoleUtils = require('../src/utils/ConsoleUtils');

args = [null,null, "E:\\dev","test","true"];
if (args.length < 3) {
    consoleUtils.out({
        "success": false,
        "type": "IllegalArgumentException",
        title: "传入参数不正确",
        content: "传入参数不正确：请传递构件源码路径信息！"
    });
} else {
    let start = Date.now();
    let componentSrcPath = args[2];
    let componentCode = args[3];
    let isExportPlugins = args[4]=="true";
    let promises = [];
    let generator = new ComponentTemplateGenerator(componentSrcPath,{
        componentCode:componentCode
    });
    promises.push(generator.generate());
    if(isExportPlugins){
        let exporter = new NodePluginExporter(componentSrcPath);
        promises.push(exporter.export('v3webpack-cli'));
    }
    Promise.all(promises).then(() => {
        consoleUtils.out({
            "success": true,
            "type": "TemplateSynced",
            title: "构件模板同步完成",
            content: "构件模板同步完成！耗时【" + (Date.now() - start) + "】毫秒"
        });
    }).catch(err => {
        consoleUtils.out({
            "success": false,
            "type": "TemplateSyncException",
            title: "构件模板同步出现错误",
            content: typeof (err) == 'string' ? err : (err.stack ? err.stack : err)
        });
    });

}