const http = require('http');
const ioUtils = require('../utils/IOUtils');
const path = require('path');
const HttpServer = require('./HttpServer');
const detectPort = require('detect-port');

module.exports = {

    _getValidPort: function () {
        return new Promise((resolve, reject) => {
            let metadata = require('../../metadata.json');
            let port = metadata.port;
            detectPort(port).then(pt=>{
                metadata.port = pt;
                let pids = metadata.pids||[];
                pids.push(process.pid);
                metadata.pids = pids;
                let pm = ioUtils.write(path.resolve(__dirname,"../../","metadata.json"),JSON.stringify(metadata,null,"\t"));
                pm.then(()=>{
                    resolve(pt);
                }).catch(err=>{
                    reject(err);
                });
            });
        });
    },

    start: function () {
        return new Promise((resolve,reject)=>{
            let promise = this._getValidPort();
            promise.then(port=>{
                let server = new HttpServer(port);
                server.start();
                resolve();
            }).catch(err=>{
                reject(err);
            });
        });
    }

};