const fs = require('fs');
const path = require('path');
const CommandInstances = {};
let fileNames = fs.readdirSync(path.resolve(__dirname, "impl"));
fileNames.forEach(fileName => {
    let Mod = require('./impl/' + fileName);
    CommandInstances[Mod.getCommand()] = new Mod();
});


module.exports = {

    getCommand: function (command) {
        if(!CommandInstances[command]){
            throw new Error(`未找到Command[${command}],请检查！`);
        }
        return CommandInstances[command];
    },

    getCommands: function () {
        return Object.values(CommandInstances);
    }

};