const Command = require('../Command');
const CommandResult = require('../CommandResult');
const CommandContextKey = require('../CommandContextKey');

class StopCommand extends Command{

    invoke(params,context){
        return new Promise((resolve,reject)=>{
            let httpServer = context.get(CommandContextKey.HTTP_SERVER);
            let promise = httpServer.close();
            promise.then(()=>{
                resolve(new CommandResult({
                    success : true,
                    type : "CommanderStop",
                    title : "关闭打包服务成功！",
                    content : ""
                }));
            }).catch(err=>{
                reject(err);
            });
        });
    }

}

StopCommand.getCommand = function(){
    return "stop";
};

module.exports = StopCommand;