const http = require('http');
const querystring = require('querystring');
const metadata = require('../../metadata.json');

module.exports = {

    request: function (data) {
        return new Promise((resolve, reject) => {
            data = data || {};
            let postData = querystring.stringify(data);
            let port = metadata.port;
            const keepAliveAgent = new http.Agent({ keepAlive: true });
            let options = {
                hostname: '127.0.0.1',
                port: port,
                path: '/',
                method: 'POST',
                agent:keepAliveAgent,
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
                    'Content-Length': Buffer.byteLength(postData)
                }
            };
            let req = http.request(options, (res) => {
                res.setEncoding('utf-8');
                let data = [];
                res.on('data', function (result) {
                    data.push(result);
                });
                res.on('end', function () {
                    resolve(JSON.parse(data.join('')));
                });
            });
            req.on('error', (err) => {
                reject(err);
            });
            req.write(postData);
            req.end();
        });
    }

};